name: msvc

on:
  push:
    branches: [ main ]
  pull_request:
    branches: [ main ]

permissions:
  contents: read

jobs:
  msvc:
    runs-on: ${{ matrix.os }}

    strategy:
      fail-fast: false
      matrix:
        os: [windows-2019, windows-latest]
        include:
          - name: msvc-2019-x86
            os: windows-2019
            ARCH: x86
          - name: msvc-2019-amd64
            os: windows-latest
            ARCH: amd64
    name: ${{ matrix.name }}

    steps:
      - uses: actions/checkout@v3
      - uses: actions/setup-python@v4
        with:
          python-version: '3.x'
      - uses: ilammy/msvc-dev-cmd@v1
        with:
          arch : ${{ matrix.ARCH }}
      - name: Upgrade pip
        run: |
          python -m pip install -U pip
      - name: Install Dependencies
        run: |
          pip install --upgrade meson ninja fonttools
      - name: Build
        run: |
          # This dir contains a pkg-config which meson will happily use and later fail, so remove it
          $env:path = ($env:path.Split(';') | Where-Object { $_ -ne 'C:\Strawberry\perl\bin' }) -join ';'

          meson setup build `
            --wrap-mode=forcefallback `
            --buildtype=release `
            -Dglib=enabled `
            -Dfreetype=enabled `
            -Dgdi=enabled `
            -Ddirectwrite=enabled

          meson compile -C build
      - name: Test
        run: |
          meson test --print-errorlogs --suite=harfbuzz -C build
